unit RepeatLabels;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ppCtrls, ppPrnabl, ppClass, ppBands, ppDB, ppCache,
  DB, DBTables, ppDBPipe, ppComm, ppRelatv, ppProd, ppReport, ppVar;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    DataSource1: TDataSource;
    Button1: TButton;
    Table1: TTable;
    ppDBPipeline1: TppDBPipeline;
    ppDetailBand1: TppDetailBand;
    ppColumnHeaderBand1: TppColumnHeaderBand;
    ppColumnFooterBand1: TppColumnFooterBand;
    ppDBText1: TppDBText;
    ppDBText2: TppDBText;
    ppLabel4: TppLabel;
    procedure Button1Click(Sender: TObject);
    procedure ppDetailBand1BeforePrint(Sender: TObject);
  private
    { Private declarations }
    FBoldNextCustNo: Boolean;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

  ppReport1.Print;

end;

procedure TForm1.ppDetailBand1BeforePrint(Sender: TObject);
var
  liCount: Integer;
begin

  {check BandsPerRecordCount, it resets to 1 when all bands for the
      prior record have gemerated }
  if (ppDetailBand1.BandsPerRecordCount = 1) then
    begin
      liCount := Round(ppReport1.DataPipeline['CustNo'] div 1000);

      ppDetailBand1.BandsPerRecord := liCount;
    end;

  // show a counter next to each label
  ppLabel4.Caption := IntToStr(ppDetailBand1.BandsPerRecordCount);

end;

end.
